# Observability # Telemetry ## List keys `client.workers.observability.telemetry.keys(TelemetryKeysParamsparams, RequestOptionsoptions?): SinglePage` **post** `/accounts/{account_id}/workers/observability/telemetry/keys` List all the keys in your telemetry events. ### Parameters - `params: TelemetryKeysParams` - `account_id: string` Path param: Your Cloudflare account ID. - `datasets?: Array` Body param: Leave this empty to use the default datasets - `filters?: Array` Body param: Apply filters to narrow key discovery. Supports nested groups via kind: 'group'. Maximum nesting depth is 4. - `UnionMember0` - `filterCombination: "and" | "or" | "AND" | "OR"` - `"and"` - `"or"` - `"AND"` - `"OR"` - `filters: Array` - `kind: "group"` - `"group"` - `WorkersObservabilityFilterLeaf` Filtering best practices: use observability_keys and observability_values to confirm available fields and values. If searching for errors, filter for $metadata.error exists. - `key: string` Filter field name. IMPORTANT: do not guess keys. Always use verified keys from previous query results or the observability_keys response. Preferred keys: $metadata.service, $metadata.origin, $metadata.trigger, $metadata.message, $metadata.error. - `operation: "includes" | "not_includes" | "starts_with" | 25 more` - `"includes"` - `"not_includes"` - `"starts_with"` - `"regex"` - `"exists"` - `"is_null"` - `"in"` - `"not_in"` - `"eq"` - `"neq"` - `"gt"` - `"gte"` - `"lt"` - `"lte"` - `"="` - `"!="` - `">"` - `">="` - `"<"` - `"<="` - `"INCLUDES"` - `"DOES_NOT_INCLUDE"` - `"MATCH_REGEX"` - `"EXISTS"` - `"DOES_NOT_EXIST"` - `"IN"` - `"NOT_IN"` - `"STARTS_WITH"` - `type: "string" | "number" | "boolean"` - `"string"` - `"number"` - `"boolean"` - `kind?: "filter"` - `"filter"` - `value?: string | number | boolean` Filter comparison value. IMPORTANT: must match actual values in your logs. Verify using previous query results or the /values endpoint. Ensure value type matches the field type. String comparisons are case-sensitive unless using specific operations. Regex uses ClickHouse RE2 syntax (no lookaheads/lookbehinds); examples: ^5\d{2}$ for HTTP 5xx, \bERROR\b for word boundary. - `string` - `number` - `boolean` - `from?: number` Body param - `keyNeedle?: KeyNeedle` Body param: If the user suggests a key, use this to narrow down the list of keys returned. Make sure matchCase is false to avoid case sensitivity issues. - `value: string | number | boolean` - `string` - `number` - `boolean` - `isRegex?: boolean` - `matchCase?: boolean` - `limit?: number` Body param: Advanced usage: set limit=1000+ to retrieve comprehensive key options without needing additional filtering. - `needle?: Needle` Body param: Search for a specific substring in any of the events - `value: string | number | boolean` - `string` - `number` - `boolean` - `isRegex?: boolean` - `matchCase?: boolean` - `to?: number` Body param ### Returns - `TelemetryKeysResponse` - `key: string` - `lastSeenAt: number` - `type: "string" | "boolean" | "number"` - `"string"` - `"boolean"` - `"number"` ### Example ```node import Cloudflare from 'cloudflare'; const client = new Cloudflare({ apiEmail: process.env['CLOUDFLARE_EMAIL'], // This is the default and can be omitted apiKey: process.env['CLOUDFLARE_API_KEY'], // This is the default and can be omitted }); // Automatically fetches more pages as needed. for await (const telemetryKeysResponse of client.workers.observability.telemetry.keys({ account_id: 'account_id', })) { console.log(telemetryKeysResponse.key); } ``` #### Response ```json { "errors": [ { "message": "message" } ], "messages": [ { "message": "Successful request" } ], "result": [ { "key": "key", "lastSeenAt": 0, "type": "string" } ], "success": true } ``` ## Run a query `client.workers.observability.telemetry.query(TelemetryQueryParamsparams, RequestOptionsoptions?): TelemetryQueryResponse` **post** `/accounts/{account_id}/workers/observability/telemetry/query` Run a temporary or saved query. ### Parameters - `params: TelemetryQueryParams` - `account_id: string` Path param: Your Cloudflare account ID. - `queryId: string` Body param: Unique identifier for the query to execute - `timeframe: Timeframe` Body param: Timeframe for your query using Unix timestamps in milliseconds. Provide from/to epoch ms; narrower timeframes provide faster responses and more specific results. - `from: number` Start timestamp for the query timeframe (Unix timestamp in milliseconds) - `to: number` End timestamp for the query timeframe (Unix timestamp in milliseconds) - `chart?: boolean` Body param: Whether to include timeseties data in the response - `compare?: boolean` Body param: Whether to include comparison data with previous time periods - `dry?: boolean` Body param: Whether to perform a dry run without saving the results of the query. Useful for validation - `granularity?: number` Body param: This is only used when the view is calculations. Leaving it empty lets Workers Observability detect the correct granularity. - `ignoreSeries?: boolean` Body param: Whether to ignore time-series data in the results and return only aggregated values - `limit?: number` Body param: Use this limit to cap the number of events returned when the view is events. - `offset?: string` Body param: Cursor pagination for event/trace/invocation views. Pass the last item's $metadata.id as the next offset. - `offsetBy?: number` Body param: Numeric offset for pattern results (top-N list). Use with limit to page pattern groups; not used by cursor pagination. - `offsetDirection?: string` Body param: Direction for offset-based pagination (e.g., 'next', 'prev') - `parameters?: Parameters` Body param: Optional parameters to pass to the query execution - `calculations?: Array` Create Calculations to compute as part of the query. - `operator: "uniq" | "count" | "max" | 35 more` - `"uniq"` - `"count"` - `"max"` - `"min"` - `"sum"` - `"avg"` - `"median"` - `"p001"` - `"p01"` - `"p05"` - `"p10"` - `"p25"` - `"p75"` - `"p90"` - `"p95"` - `"p99"` - `"p999"` - `"stddev"` - `"variance"` - `"COUNT_DISTINCT"` - `"COUNT"` - `"MAX"` - `"MIN"` - `"SUM"` - `"AVG"` - `"MEDIAN"` - `"P001"` - `"P01"` - `"P05"` - `"P10"` - `"P25"` - `"P75"` - `"P90"` - `"P95"` - `"P99"` - `"P999"` - `"STDDEV"` - `"VARIANCE"` - `alias?: string` - `key?: string` The key to use for the calculation. This key must exist in the logs. Use the observability_keys response to confirm. Do not guess keys. - `keyType?: "string" | "number" | "boolean"` - `"string"` - `"number"` - `"boolean"` - `datasets?: Array` Set the Datasets to query. Leave it empty to query all the datasets. - `filterCombination?: "and" | "or" | "AND" | "OR"` Set a Flag to describe how to combine the filters on the query. - `"and"` - `"or"` - `"AND"` - `"OR"` - `filters?: Array` Configure the Filters to apply to the query. Supports nested groups via kind: 'group'. Maximum nesting depth is 4. - `UnionMember0` - `filterCombination: "and" | "or" | "AND" | "OR"` - `"and"` - `"or"` - `"AND"` - `"OR"` - `filters: Array` - `kind: "group"` - `"group"` - `WorkersObservabilityFilterLeaf` Filtering best practices: use observability_keys and observability_values to confirm available fields and values. If searching for errors, filter for $metadata.error exists. - `key: string` Filter field name. IMPORTANT: do not guess keys. Always use verified keys from previous query results or the observability_keys response. Preferred keys: $metadata.service, $metadata.origin, $metadata.trigger, $metadata.message, $metadata.error. - `operation: "includes" | "not_includes" | "starts_with" | 25 more` - `"includes"` - `"not_includes"` - `"starts_with"` - `"regex"` - `"exists"` - `"is_null"` - `"in"` - `"not_in"` - `"eq"` - `"neq"` - `"gt"` - `"gte"` - `"lt"` - `"lte"` - `"="` - `"!="` - `">"` - `">="` - `"<"` - `"<="` - `"INCLUDES"` - `"DOES_NOT_INCLUDE"` - `"MATCH_REGEX"` - `"EXISTS"` - `"DOES_NOT_EXIST"` - `"IN"` - `"NOT_IN"` - `"STARTS_WITH"` - `type: "string" | "number" | "boolean"` - `"string"` - `"number"` - `"boolean"` - `kind?: "filter"` - `"filter"` - `value?: string | number | boolean` Filter comparison value. IMPORTANT: must match actual values in your logs. Verify using previous query results or the /values endpoint. Ensure value type matches the field type. String comparisons are case-sensitive unless using specific operations. Regex uses ClickHouse RE2 syntax (no lookaheads/lookbehinds); examples: ^5\d{2}$ for HTTP 5xx, \bERROR\b for word boundary. - `string` - `number` - `boolean` - `groupBys?: Array` Define how to group the results of the query. - `type: "string" | "number" | "boolean"` - `"string"` - `"number"` - `"boolean"` - `value: string` - `havings?: Array` Configure the Having clauses that filter on calculations in the query result. - `key: string` - `operation: "eq" | "neq" | "gt" | 3 more` - `"eq"` - `"neq"` - `"gt"` - `"gte"` - `"lt"` - `"lte"` - `value: number` - `limit?: number` Set a limit on the number of results / records returned by the query - `needle?: Needle` Define an expression to search using full-text search. - `value: string | number | boolean` - `string` - `number` - `boolean` - `isRegex?: boolean` - `matchCase?: boolean` - `orderBy?: OrderBy` Configure the order of the results returned by the query. - `value: string` Configure which Calculation to order the results by. - `order?: "asc" | "desc"` Set the order of the results - `"asc"` - `"desc"` - `view?: "traces" | "events" | "calculations" | 3 more` Body param: Examples by view type. Events: show errors for a worker in the last 30 minutes. Calculations: p99 of wall time or count by status code. Invocations: find a specific request that resulted in a 500. - `"traces"` - `"events"` - `"calculations"` - `"invocations"` - `"requests"` - `"agents"` ### Returns - `TelemetryQueryResponse` - `run: Run` A Workers Observability Query Object - `id: string` - `accountId: string` - `dry: boolean` - `granularity: number` - `query: Query` - `id: string` - `adhoc: boolean` If the query wasn't explcitly saved - `created: string` - `createdBy: string` - `description: string | null` - `name: string` Query name - `parameters: Parameters` - `calculations?: Array` Create Calculations to compute as part of the query. - `operator: "uniq" | "count" | "max" | 35 more` - `"uniq"` - `"count"` - `"max"` - `"min"` - `"sum"` - `"avg"` - `"median"` - `"p001"` - `"p01"` - `"p05"` - `"p10"` - `"p25"` - `"p75"` - `"p90"` - `"p95"` - `"p99"` - `"p999"` - `"stddev"` - `"variance"` - `"COUNT_DISTINCT"` - `"COUNT"` - `"MAX"` - `"MIN"` - `"SUM"` - `"AVG"` - `"MEDIAN"` - `"P001"` - `"P01"` - `"P05"` - `"P10"` - `"P25"` - `"P75"` - `"P90"` - `"P95"` - `"P99"` - `"P999"` - `"STDDEV"` - `"VARIANCE"` - `alias?: string` - `key?: string` - `keyType?: "string" | "number" | "boolean"` - `"string"` - `"number"` - `"boolean"` - `datasets?: Array` Set the Datasets to query. Leave it empty to query all the datasets. - `filterCombination?: "and" | "or" | "AND" | "OR"` Set a Flag to describe how to combine the filters on the query. - `"and"` - `"or"` - `"AND"` - `"OR"` - `filters?: Array` Configure the Filters to apply to the query. Supports nested groups via kind: 'group'. - `UnionMember0` - `filterCombination: "and" | "or" | "AND" | "OR"` - `"and"` - `"or"` - `"AND"` - `"OR"` - `filters: Array` - `kind: "group"` - `"group"` - `WorkersObservabilityFilterLeaf` Filtering best practices: use observability_keys and observability_values to confirm available fields and values. If searching for errors, filter for $metadata.error exists. - `key: string` Filter field name. IMPORTANT: do not guess keys. Always use verified keys from previous query results or the observability_keys response. Preferred keys: $metadata.service, $metadata.origin, $metadata.trigger, $metadata.message, $metadata.error. - `operation: "includes" | "not_includes" | "starts_with" | 25 more` - `"includes"` - `"not_includes"` - `"starts_with"` - `"regex"` - `"exists"` - `"is_null"` - `"in"` - `"not_in"` - `"eq"` - `"neq"` - `"gt"` - `"gte"` - `"lt"` - `"lte"` - `"="` - `"!="` - `">"` - `">="` - `"<"` - `"<="` - `"INCLUDES"` - `"DOES_NOT_INCLUDE"` - `"MATCH_REGEX"` - `"EXISTS"` - `"DOES_NOT_EXIST"` - `"IN"` - `"NOT_IN"` - `"STARTS_WITH"` - `type: "string" | "number" | "boolean"` - `"string"` - `"number"` - `"boolean"` - `kind?: "filter"` - `"filter"` - `value?: string | number | boolean` Filter comparison value. IMPORTANT: must match actual values in your logs. Verify using previous query results or the /values endpoint. Ensure value type matches the field type. String comparisons are case-sensitive unless using specific operations. Regex uses ClickHouse RE2 syntax (no lookaheads/lookbehinds); examples: ^5\d{2}$ for HTTP 5xx, \bERROR\b for word boundary. - `string` - `number` - `boolean` - `groupBys?: Array` Define how to group the results of the query. - `type: "string" | "number" | "boolean"` - `"string"` - `"number"` - `"boolean"` - `value: string` - `havings?: Array` Configure the Having clauses that filter on calculations in the query result. - `key: string` - `operation: "eq" | "neq" | "gt" | 3 more` - `"eq"` - `"neq"` - `"gt"` - `"gte"` - `"lt"` - `"lte"` - `value: number` - `limit?: number` Set a limit on the number of results / records returned by the query - `needle?: Needle` Define an expression to search using full-text search. - `value: Value` - `isRegex?: boolean` - `matchCase?: boolean` - `orderBy?: OrderBy` Configure the order of the results returned by the query. - `value: string` Configure which Calculation to order the results by. - `order?: "asc" | "desc"` Set the order of the results - `"asc"` - `"desc"` - `updated: string` - `updatedBy: string` - `status: "STARTED" | "COMPLETED"` - `"STARTED"` - `"COMPLETED"` - `timeframe: Timeframe` Time range for the query execution - `from: number` Start timestamp for the query timeframe (Unix timestamp in milliseconds) - `to: number` End timestamp for the query timeframe (Unix timestamp in milliseconds) - `userId: string` - `created?: string` - `statistics?: Statistics` - `bytes_read: number` Number of uncompressed bytes read from the table. - `elapsed: number` Time in seconds for the query to run. - `rows_read: number` Number of rows scanned from the table. - `abr_level?: number` The level of Adaptive Bit Rate (ABR) sampling used for the query. If empty the ABR level is 1 - `updated?: string` - `statistics: Statistics` The statistics object contains information about query performance from the database, it does not include any network latency - `bytes_read: number` Number of uncompressed bytes read from the table. - `elapsed: number` Time in seconds for the query to run. - `rows_read: number` Number of rows scanned from the table. - `abr_level?: number` The level of Adaptive Bit Rate (ABR) sampling used for the query. If empty the ABR level is 1 - `agents?: Array` - `agentClass: string` - `eventTypeCounts: Record` - `firstEventMs: number` - `hasErrors: boolean` - `lastEventMs: number` - `namespace: string` - `service: string` - `totalEvents: number` - `calculations?: Array` - `aggregates: Array` - `count: number` - `interval: number` - `sampleInterval: number` - `value: number` - `groups?: Array` - `key: string` - `value: string | number | boolean` - `string` - `number` - `boolean` - `calculation: string` - `series: Array` - `data: Array` - `count: number` - `interval: number` - `sampleInterval: number` - `value: number` - `firstSeen?: string` - `groups?: Array` - `key: string` - `value: string | number | boolean` - `string` - `number` - `boolean` - `lastSeen?: string` - `time: string` - `alias?: string` - `compare?: Array` - `aggregates: Array` - `count: number` - `interval: number` - `sampleInterval: number` - `value: number` - `groups?: Array` - `key: string` - `value: string | number | boolean` - `string` - `number` - `boolean` - `calculation: string` - `series: Array` - `data: Array` - `count: number` - `interval: number` - `sampleInterval: number` - `value: number` - `firstSeen?: string` - `groups?: Array` - `key: string` - `value: string | number | boolean` - `string` - `number` - `boolean` - `lastSeen?: string` - `time: string` - `alias?: string` - `events?: Events` - `count?: number` - `events?: Array` - `"$metadata": Metadata` - `id: string` Unique event ID. Use as the cursor for offset-based pagination. - `account?: string` - `cloudService?: string` - `coldStart?: number` - `cost?: number` - `duration?: number` - `endTime?: number` - `error?: string` - `errorTemplate?: string` - `fingerprint?: string` - `level?: string` - `message?: string` - `messageTemplate?: string` - `metricName?: string` - `origin?: string` - `parentSpanId?: string` - `provider?: string` - `region?: string` - `requestId?: string` - `service?: string` - `spanId?: string` - `spanName?: string` - `stackId?: string` - `startTime?: number` - `statusCode?: number` - `traceDuration?: number` - `traceId?: string` - `transactionName?: string` - `trigger?: string` - `type?: string` - `url?: string` - `dataset: string` - `source: string | unknown` - `string` - `unknown` - `timestamp: number` - `"$containers"?: unknown` Cloudflare Containers event information enriches your logs so you can easily identify and debug issues. - `"$workers"?: UnionMember0 | UnionMember1` Cloudflare Workers event information enriches your logs so you can easily identify and debug issues. - `UnionMember0` - `eventType: "fetch" | "scheduled" | "alarm" | 8 more` - `"fetch"` - `"scheduled"` - `"alarm"` - `"cron"` - `"queue"` - `"email"` - `"tail"` - `"rpc"` - `"websocket"` - `"workflow"` - `"unknown"` - `requestId: string` - `scriptName: string` - `durableObjectId?: string` - `entrypoint?: string` - `event?: Record` - `executionModel?: "durableObject" | "stateless"` - `"durableObject"` - `"stateless"` - `outcome?: string` - `scriptVersion?: ScriptVersion` - `id?: string` - `message?: string` - `tag?: string` - `truncated?: boolean` - `UnionMember1` - `cpuTimeMs: number` - `eventType: "fetch" | "scheduled" | "alarm" | 8 more` - `"fetch"` - `"scheduled"` - `"alarm"` - `"cron"` - `"queue"` - `"email"` - `"tail"` - `"rpc"` - `"websocket"` - `"workflow"` - `"unknown"` - `outcome: string` - `requestId: string` - `scriptName: string` - `wallTimeMs: number` - `diagnosticsChannelEvents?: Array` - `channel: string` - `message: string` - `timestamp: number` - `dispatchNamespace?: string` - `durableObjectId?: string` - `entrypoint?: string` - `event?: Record` - `executionModel?: "durableObject" | "stateless"` - `"durableObject"` - `"stateless"` - `scriptVersion?: ScriptVersion` - `id?: string` - `message?: string` - `tag?: string` - `truncated?: boolean` - `fields?: Array` - `key: string` - `type: string` - `series?: Array` - `data: Array` - `aggregates: Aggregates` - `_count: number` - `_interval: number` - `_firstSeen?: string` - `_lastSeen?: string` - `bin?: unknown` - `count: number` - `interval: number` - `sampleInterval: number` - `errors?: number` - `groups?: Record` Groups in the query results. - `string` - `number` - `boolean` - `time: string` - `invocations?: Record>` - `"$metadata": Metadata` - `id: string` Unique event ID. Use as the cursor for offset-based pagination. - `account?: string` - `cloudService?: string` - `coldStart?: number` - `cost?: number` - `duration?: number` - `endTime?: number` - `error?: string` - `errorTemplate?: string` - `fingerprint?: string` - `level?: string` - `message?: string` - `messageTemplate?: string` - `metricName?: string` - `origin?: string` - `parentSpanId?: string` - `provider?: string` - `region?: string` - `requestId?: string` - `service?: string` - `spanId?: string` - `spanName?: string` - `stackId?: string` - `startTime?: number` - `statusCode?: number` - `traceDuration?: number` - `traceId?: string` - `transactionName?: string` - `trigger?: string` - `type?: string` - `url?: string` - `dataset: string` - `source: string | unknown` - `string` - `unknown` - `timestamp: number` - `"$containers"?: unknown` Cloudflare Containers event information enriches your logs so you can easily identify and debug issues. - `"$workers"?: UnionMember0 | UnionMember1` Cloudflare Workers event information enriches your logs so you can easily identify and debug issues. - `UnionMember0` - `eventType: "fetch" | "scheduled" | "alarm" | 8 more` - `"fetch"` - `"scheduled"` - `"alarm"` - `"cron"` - `"queue"` - `"email"` - `"tail"` - `"rpc"` - `"websocket"` - `"workflow"` - `"unknown"` - `requestId: string` - `scriptName: string` - `durableObjectId?: string` - `entrypoint?: string` - `event?: Record` - `executionModel?: "durableObject" | "stateless"` - `"durableObject"` - `"stateless"` - `outcome?: string` - `scriptVersion?: ScriptVersion` - `id?: string` - `message?: string` - `tag?: string` - `truncated?: boolean` - `UnionMember1` - `cpuTimeMs: number` - `eventType: "fetch" | "scheduled" | "alarm" | 8 more` - `"fetch"` - `"scheduled"` - `"alarm"` - `"cron"` - `"queue"` - `"email"` - `"tail"` - `"rpc"` - `"websocket"` - `"workflow"` - `"unknown"` - `outcome: string` - `requestId: string` - `scriptName: string` - `wallTimeMs: number` - `diagnosticsChannelEvents?: Array` - `channel: string` - `message: string` - `timestamp: number` - `dispatchNamespace?: string` - `durableObjectId?: string` - `entrypoint?: string` - `event?: Record` - `executionModel?: "durableObject" | "stateless"` - `"durableObject"` - `"stateless"` - `scriptVersion?: ScriptVersion` - `id?: string` - `message?: string` - `tag?: string` - `truncated?: boolean` - `traces?: Array` - `rootSpanName: string` - `rootTransactionName: string` - `service: Array` - `spans: number` - `traceDurationMs: number` - `traceEndMs: number` - `traceId: string` - `traceStartMs: number` - `errors?: Array` ### Example ```node import Cloudflare from 'cloudflare'; const client = new Cloudflare({ apiEmail: process.env['CLOUDFLARE_EMAIL'], // This is the default and can be omitted apiKey: process.env['CLOUDFLARE_API_KEY'], // This is the default and can be omitted }); const response = await client.workers.observability.telemetry.query({ account_id: 'account_id', queryId: 'queryId', timeframe: { from: 0, to: 0 }, }); console.log(response.run); ``` #### Response ```json { "errors": [ { "message": "message" } ], "messages": [ { "message": "Successful request" } ], "result": { "run": { "id": "id", "accountId": "accountId", "dry": true, "granularity": 0, "query": { "id": "id", "adhoc": true, "created": "created", "createdBy": "createdBy", "description": "Query description", "name": "x", "parameters": { "calculations": [ { "operator": "uniq", "alias": "alias", "key": "key", "keyType": "string" } ], "datasets": [ "string" ], "filterCombination": "and", "filters": [ { "filterCombination": "and", "filters": [ {} ], "kind": "group" } ], "groupBys": [ { "type": "string", "value": "value" } ], "havings": [ { "key": "key", "operation": "eq", "value": 0 } ], "limit": 0, "needle": { "value": { "0": "s", "1": "t", "2": "r", "3": "i", "4": "n", "5": "g" }, "isRegex": true, "matchCase": true }, "orderBy": { "value": "value", "order": "asc" } }, "updated": "updated", "updatedBy": "updatedBy" }, "status": "STARTED", "timeframe": { "from": 0, "to": 0 }, "userId": "userId", "created": "created", "statistics": { "bytes_read": 0, "elapsed": 0, "rows_read": 0, "abr_level": 0 }, "updated": "updated" }, "statistics": { "bytes_read": 0, "elapsed": 0, "rows_read": 0, "abr_level": 0 }, "agents": [ { "agentClass": "agentClass", "eventTypeCounts": { "foo": 0 }, "firstEventMs": 0, "hasErrors": true, "lastEventMs": 0, "namespace": "namespace", "service": "service", "totalEvents": 0 } ], "calculations": [ { "aggregates": [ { "count": 0, "interval": 0, "sampleInterval": 0, "value": 0, "groups": [ { "key": "key", "value": "string" } ] } ], "calculation": "calculation", "series": [ { "data": [ { "count": 0, "interval": 0, "sampleInterval": 0, "value": 0, "firstSeen": "firstSeen", "groups": [ { "key": "key", "value": "string" } ], "lastSeen": "lastSeen" } ], "time": "time" } ], "alias": "alias" } ], "compare": [ { "aggregates": [ { "count": 0, "interval": 0, "sampleInterval": 0, "value": 0, "groups": [ { "key": "key", "value": "string" } ] } ], "calculation": "calculation", "series": [ { "data": [ { "count": 0, "interval": 0, "sampleInterval": 0, "value": 0, "firstSeen": "firstSeen", "groups": [ { "key": "key", "value": "string" } ], "lastSeen": "lastSeen" } ], "time": "time" } ], "alias": "alias" } ], "events": { "count": 0, "events": [ { "$metadata": { "id": "id", "account": "account", "cloudService": "cloudService", "coldStart": 1, "cost": 1, "duration": 1, "endTime": 0, "error": "error", "errorTemplate": "errorTemplate", "fingerprint": "fingerprint", "level": "level", "message": "message", "messageTemplate": "messageTemplate", "metricName": "metricName", "origin": "origin", "parentSpanId": "parentSpanId", "provider": "provider", "region": "region", "requestId": "requestId", "service": "service", "spanId": "spanId", "spanName": "spanName", "stackId": "stackId", "startTime": 0, "statusCode": 1, "traceDuration": 1, "traceId": "traceId", "transactionName": "transactionName", "trigger": "trigger", "type": "type", "url": "url" }, "dataset": "dataset", "source": "string", "timestamp": 0, "$containers": {}, "$workers": { "eventType": "fetch", "requestId": "requestId", "scriptName": "scriptName", "durableObjectId": "durableObjectId", "entrypoint": "entrypoint", "event": { "foo": "bar" }, "executionModel": "durableObject", "outcome": "outcome", "scriptVersion": { "id": "id", "message": "message", "tag": "tag" }, "truncated": true } } ], "fields": [ { "key": "key", "type": "type" } ], "series": [ { "data": [ { "aggregates": { "_count": 1, "_interval": 1, "_firstSeen": "_firstSeen", "_lastSeen": "_lastSeen", "bin": {} }, "count": 0, "interval": 0, "sampleInterval": 0, "errors": 0, "groups": { "foo": "string" } } ], "time": "time" } ] }, "invocations": { "foo": [ { "$metadata": { "id": "id", "account": "account", "cloudService": "cloudService", "coldStart": 1, "cost": 1, "duration": 1, "endTime": 0, "error": "error", "errorTemplate": "errorTemplate", "fingerprint": "fingerprint", "level": "level", "message": "message", "messageTemplate": "messageTemplate", "metricName": "metricName", "origin": "origin", "parentSpanId": "parentSpanId", "provider": "provider", "region": "region", "requestId": "requestId", "service": "service", "spanId": "spanId", "spanName": "spanName", "stackId": "stackId", "startTime": 0, "statusCode": 1, "traceDuration": 1, "traceId": "traceId", "transactionName": "transactionName", "trigger": "trigger", "type": "type", "url": "url" }, "dataset": "dataset", "source": "string", "timestamp": 0, "$containers": {}, "$workers": { "eventType": "fetch", "requestId": "requestId", "scriptName": "scriptName", "durableObjectId": "durableObjectId", "entrypoint": "entrypoint", "event": { "foo": "bar" }, "executionModel": "durableObject", "outcome": "outcome", "scriptVersion": { "id": "id", "message": "message", "tag": "tag" }, "truncated": true } } ] }, "traces": [ { "rootSpanName": "rootSpanName", "rootTransactionName": "rootTransactionName", "service": [ "string" ], "spans": 0, "traceDurationMs": 0, "traceEndMs": 0, "traceId": "traceId", "traceStartMs": 0, "errors": [ "string" ] } ] }, "success": true } ``` ## List values `client.workers.observability.telemetry.values(TelemetryValuesParamsparams, RequestOptionsoptions?): SinglePage` **post** `/accounts/{account_id}/workers/observability/telemetry/values` List unique values found in your events. ### Parameters - `params: TelemetryValuesParams` - `account_id: string` Path param: Your Cloudflare account ID. - `datasets: Array` Body param: Leave this empty to use the default datasets - `key: string` Body param - `timeframe: Timeframe` Body param - `from: number` - `to: number` - `type: "string" | "boolean" | "number"` Body param - `"string"` - `"boolean"` - `"number"` - `filters?: Array` Body param: Apply filters before listing values. Supports nested groups via kind: 'group'. Maximum nesting depth is 4. - `UnionMember0` - `filterCombination: "and" | "or" | "AND" | "OR"` - `"and"` - `"or"` - `"AND"` - `"OR"` - `filters: Array` - `kind: "group"` - `"group"` - `WorkersObservabilityFilterLeaf` Filtering best practices: use observability_keys and observability_values to confirm available fields and values. If searching for errors, filter for $metadata.error exists. - `key: string` Filter field name. IMPORTANT: do not guess keys. Always use verified keys from previous query results or the observability_keys response. Preferred keys: $metadata.service, $metadata.origin, $metadata.trigger, $metadata.message, $metadata.error. - `operation: "includes" | "not_includes" | "starts_with" | 25 more` - `"includes"` - `"not_includes"` - `"starts_with"` - `"regex"` - `"exists"` - `"is_null"` - `"in"` - `"not_in"` - `"eq"` - `"neq"` - `"gt"` - `"gte"` - `"lt"` - `"lte"` - `"="` - `"!="` - `">"` - `">="` - `"<"` - `"<="` - `"INCLUDES"` - `"DOES_NOT_INCLUDE"` - `"MATCH_REGEX"` - `"EXISTS"` - `"DOES_NOT_EXIST"` - `"IN"` - `"NOT_IN"` - `"STARTS_WITH"` - `type: "string" | "number" | "boolean"` - `"string"` - `"number"` - `"boolean"` - `kind?: "filter"` - `"filter"` - `value?: string | number | boolean` Filter comparison value. IMPORTANT: must match actual values in your logs. Verify using previous query results or the /values endpoint. Ensure value type matches the field type. String comparisons are case-sensitive unless using specific operations. Regex uses ClickHouse RE2 syntax (no lookaheads/lookbehinds); examples: ^5\d{2}$ for HTTP 5xx, \bERROR\b for word boundary. - `string` - `number` - `boolean` - `limit?: number` Body param - `needle?: Needle` Body param: Search for a specific substring in the event. - `value: string | number | boolean` - `string` - `number` - `boolean` - `isRegex?: boolean` - `matchCase?: boolean` ### Returns - `TelemetryValuesResponse` - `dataset: string` - `key: string` - `type: "string" | "boolean" | "number"` - `"string"` - `"boolean"` - `"number"` - `value: string | number | boolean` - `string` - `number` - `boolean` ### Example ```node import Cloudflare from 'cloudflare'; const client = new Cloudflare({ apiEmail: process.env['CLOUDFLARE_EMAIL'], // This is the default and can be omitted apiKey: process.env['CLOUDFLARE_API_KEY'], // This is the default and can be omitted }); // Automatically fetches more pages as needed. for await (const telemetryValuesResponse of client.workers.observability.telemetry.values({ account_id: 'account_id', datasets: ['string'], key: 'key', timeframe: { from: 0, to: 0 }, type: 'string', })) { console.log(telemetryValuesResponse.dataset); } ``` #### Response ```json { "errors": [ { "message": "message" } ], "messages": [ { "message": "Successful request" } ], "result": [ { "dataset": "dataset", "key": "key", "type": "string", "value": "string" } ], "success": true } ``` ## Domain Types ### Telemetry Keys Response - `TelemetryKeysResponse` - `key: string` - `lastSeenAt: number` - `type: "string" | "boolean" | "number"` - `"string"` - `"boolean"` - `"number"` ### Telemetry Query Response - `TelemetryQueryResponse` - `run: Run` A Workers Observability Query Object - `id: string` - `accountId: string` - `dry: boolean` - `granularity: number` - `query: Query` - `id: string` - `adhoc: boolean` If the query wasn't explcitly saved - `created: string` - `createdBy: string` - `description: string | null` - `name: string` Query name - `parameters: Parameters` - `calculations?: Array` Create Calculations to compute as part of the query. - `operator: "uniq" | "count" | "max" | 35 more` - `"uniq"` - `"count"` - `"max"` - `"min"` - `"sum"` - `"avg"` - `"median"` - `"p001"` - `"p01"` - `"p05"` - `"p10"` - `"p25"` - `"p75"` - `"p90"` - `"p95"` - `"p99"` - `"p999"` - `"stddev"` - `"variance"` - `"COUNT_DISTINCT"` - `"COUNT"` - `"MAX"` - `"MIN"` - `"SUM"` - `"AVG"` - `"MEDIAN"` - `"P001"` - `"P01"` - `"P05"` - `"P10"` - `"P25"` - `"P75"` - `"P90"` - `"P95"` - `"P99"` - `"P999"` - `"STDDEV"` - `"VARIANCE"` - `alias?: string` - `key?: string` - `keyType?: "string" | "number" | "boolean"` - `"string"` - `"number"` - `"boolean"` - `datasets?: Array` Set the Datasets to query. Leave it empty to query all the datasets. - `filterCombination?: "and" | "or" | "AND" | "OR"` Set a Flag to describe how to combine the filters on the query. - `"and"` - `"or"` - `"AND"` - `"OR"` - `filters?: Array` Configure the Filters to apply to the query. Supports nested groups via kind: 'group'. - `UnionMember0` - `filterCombination: "and" | "or" | "AND" | "OR"` - `"and"` - `"or"` - `"AND"` - `"OR"` - `filters: Array` - `kind: "group"` - `"group"` - `WorkersObservabilityFilterLeaf` Filtering best practices: use observability_keys and observability_values to confirm available fields and values. If searching for errors, filter for $metadata.error exists. - `key: string` Filter field name. IMPORTANT: do not guess keys. Always use verified keys from previous query results or the observability_keys response. Preferred keys: $metadata.service, $metadata.origin, $metadata.trigger, $metadata.message, $metadata.error. - `operation: "includes" | "not_includes" | "starts_with" | 25 more` - `"includes"` - `"not_includes"` - `"starts_with"` - `"regex"` - `"exists"` - `"is_null"` - `"in"` - `"not_in"` - `"eq"` - `"neq"` - `"gt"` - `"gte"` - `"lt"` - `"lte"` - `"="` - `"!="` - `">"` - `">="` - `"<"` - `"<="` - `"INCLUDES"` - `"DOES_NOT_INCLUDE"` - `"MATCH_REGEX"` - `"EXISTS"` - `"DOES_NOT_EXIST"` - `"IN"` - `"NOT_IN"` - `"STARTS_WITH"` - `type: "string" | "number" | "boolean"` - `"string"` - `"number"` - `"boolean"` - `kind?: "filter"` - `"filter"` - `value?: string | number | boolean` Filter comparison value. IMPORTANT: must match actual values in your logs. Verify using previous query results or the /values endpoint. Ensure value type matches the field type. String comparisons are case-sensitive unless using specific operations. Regex uses ClickHouse RE2 syntax (no lookaheads/lookbehinds); examples: ^5\d{2}$ for HTTP 5xx, \bERROR\b for word boundary. - `string` - `number` - `boolean` - `groupBys?: Array` Define how to group the results of the query. - `type: "string" | "number" | "boolean"` - `"string"` - `"number"` - `"boolean"` - `value: string` - `havings?: Array` Configure the Having clauses that filter on calculations in the query result. - `key: string` - `operation: "eq" | "neq" | "gt" | 3 more` - `"eq"` - `"neq"` - `"gt"` - `"gte"` - `"lt"` - `"lte"` - `value: number` - `limit?: number` Set a limit on the number of results / records returned by the query - `needle?: Needle` Define an expression to search using full-text search. - `value: Value` - `isRegex?: boolean` - `matchCase?: boolean` - `orderBy?: OrderBy` Configure the order of the results returned by the query. - `value: string` Configure which Calculation to order the results by. - `order?: "asc" | "desc"` Set the order of the results - `"asc"` - `"desc"` - `updated: string` - `updatedBy: string` - `status: "STARTED" | "COMPLETED"` - `"STARTED"` - `"COMPLETED"` - `timeframe: Timeframe` Time range for the query execution - `from: number` Start timestamp for the query timeframe (Unix timestamp in milliseconds) - `to: number` End timestamp for the query timeframe (Unix timestamp in milliseconds) - `userId: string` - `created?: string` - `statistics?: Statistics` - `bytes_read: number` Number of uncompressed bytes read from the table. - `elapsed: number` Time in seconds for the query to run. - `rows_read: number` Number of rows scanned from the table. - `abr_level?: number` The level of Adaptive Bit Rate (ABR) sampling used for the query. If empty the ABR level is 1 - `updated?: string` - `statistics: Statistics` The statistics object contains information about query performance from the database, it does not include any network latency - `bytes_read: number` Number of uncompressed bytes read from the table. - `elapsed: number` Time in seconds for the query to run. - `rows_read: number` Number of rows scanned from the table. - `abr_level?: number` The level of Adaptive Bit Rate (ABR) sampling used for the query. If empty the ABR level is 1 - `agents?: Array` - `agentClass: string` - `eventTypeCounts: Record` - `firstEventMs: number` - `hasErrors: boolean` - `lastEventMs: number` - `namespace: string` - `service: string` - `totalEvents: number` - `calculations?: Array` - `aggregates: Array` - `count: number` - `interval: number` - `sampleInterval: number` - `value: number` - `groups?: Array` - `key: string` - `value: string | number | boolean` - `string` - `number` - `boolean` - `calculation: string` - `series: Array` - `data: Array` - `count: number` - `interval: number` - `sampleInterval: number` - `value: number` - `firstSeen?: string` - `groups?: Array` - `key: string` - `value: string | number | boolean` - `string` - `number` - `boolean` - `lastSeen?: string` - `time: string` - `alias?: string` - `compare?: Array` - `aggregates: Array` - `count: number` - `interval: number` - `sampleInterval: number` - `value: number` - `groups?: Array` - `key: string` - `value: string | number | boolean` - `string` - `number` - `boolean` - `calculation: string` - `series: Array` - `data: Array` - `count: number` - `interval: number` - `sampleInterval: number` - `value: number` - `firstSeen?: string` - `groups?: Array` - `key: string` - `value: string | number | boolean` - `string` - `number` - `boolean` - `lastSeen?: string` - `time: string` - `alias?: string` - `events?: Events` - `count?: number` - `events?: Array` - `"$metadata": Metadata` - `id: string` Unique event ID. Use as the cursor for offset-based pagination. - `account?: string` - `cloudService?: string` - `coldStart?: number` - `cost?: number` - `duration?: number` - `endTime?: number` - `error?: string` - `errorTemplate?: string` - `fingerprint?: string` - `level?: string` - `message?: string` - `messageTemplate?: string` - `metricName?: string` - `origin?: string` - `parentSpanId?: string` - `provider?: string` - `region?: string` - `requestId?: string` - `service?: string` - `spanId?: string` - `spanName?: string` - `stackId?: string` - `startTime?: number` - `statusCode?: number` - `traceDuration?: number` - `traceId?: string` - `transactionName?: string` - `trigger?: string` - `type?: string` - `url?: string` - `dataset: string` - `source: string | unknown` - `string` - `unknown` - `timestamp: number` - `"$containers"?: unknown` Cloudflare Containers event information enriches your logs so you can easily identify and debug issues. - `"$workers"?: UnionMember0 | UnionMember1` Cloudflare Workers event information enriches your logs so you can easily identify and debug issues. - `UnionMember0` - `eventType: "fetch" | "scheduled" | "alarm" | 8 more` - `"fetch"` - `"scheduled"` - `"alarm"` - `"cron"` - `"queue"` - `"email"` - `"tail"` - `"rpc"` - `"websocket"` - `"workflow"` - `"unknown"` - `requestId: string` - `scriptName: string` - `durableObjectId?: string` - `entrypoint?: string` - `event?: Record` - `executionModel?: "durableObject" | "stateless"` - `"durableObject"` - `"stateless"` - `outcome?: string` - `scriptVersion?: ScriptVersion` - `id?: string` - `message?: string` - `tag?: string` - `truncated?: boolean` - `UnionMember1` - `cpuTimeMs: number` - `eventType: "fetch" | "scheduled" | "alarm" | 8 more` - `"fetch"` - `"scheduled"` - `"alarm"` - `"cron"` - `"queue"` - `"email"` - `"tail"` - `"rpc"` - `"websocket"` - `"workflow"` - `"unknown"` - `outcome: string` - `requestId: string` - `scriptName: string` - `wallTimeMs: number` - `diagnosticsChannelEvents?: Array` - `channel: string` - `message: string` - `timestamp: number` - `dispatchNamespace?: string` - `durableObjectId?: string` - `entrypoint?: string` - `event?: Record` - `executionModel?: "durableObject" | "stateless"` - `"durableObject"` - `"stateless"` - `scriptVersion?: ScriptVersion` - `id?: string` - `message?: string` - `tag?: string` - `truncated?: boolean` - `fields?: Array` - `key: string` - `type: string` - `series?: Array` - `data: Array` - `aggregates: Aggregates` - `_count: number` - `_interval: number` - `_firstSeen?: string` - `_lastSeen?: string` - `bin?: unknown` - `count: number` - `interval: number` - `sampleInterval: number` - `errors?: number` - `groups?: Record` Groups in the query results. - `string` - `number` - `boolean` - `time: string` - `invocations?: Record>` - `"$metadata": Metadata` - `id: string` Unique event ID. Use as the cursor for offset-based pagination. - `account?: string` - `cloudService?: string` - `coldStart?: number` - `cost?: number` - `duration?: number` - `endTime?: number` - `error?: string` - `errorTemplate?: string` - `fingerprint?: string` - `level?: string` - `message?: string` - `messageTemplate?: string` - `metricName?: string` - `origin?: string` - `parentSpanId?: string` - `provider?: string` - `region?: string` - `requestId?: string` - `service?: string` - `spanId?: string` - `spanName?: string` - `stackId?: string` - `startTime?: number` - `statusCode?: number` - `traceDuration?: number` - `traceId?: string` - `transactionName?: string` - `trigger?: string` - `type?: string` - `url?: string` - `dataset: string` - `source: string | unknown` - `string` - `unknown` - `timestamp: number` - `"$containers"?: unknown` Cloudflare Containers event information enriches your logs so you can easily identify and debug issues. - `"$workers"?: UnionMember0 | UnionMember1` Cloudflare Workers event information enriches your logs so you can easily identify and debug issues. - `UnionMember0` - `eventType: "fetch" | "scheduled" | "alarm" | 8 more` - `"fetch"` - `"scheduled"` - `"alarm"` - `"cron"` - `"queue"` - `"email"` - `"tail"` - `"rpc"` - `"websocket"` - `"workflow"` - `"unknown"` - `requestId: string` - `scriptName: string` - `durableObjectId?: string` - `entrypoint?: string` - `event?: Record` - `executionModel?: "durableObject" | "stateless"` - `"durableObject"` - `"stateless"` - `outcome?: string` - `scriptVersion?: ScriptVersion` - `id?: string` - `message?: string` - `tag?: string` - `truncated?: boolean` - `UnionMember1` - `cpuTimeMs: number` - `eventType: "fetch" | "scheduled" | "alarm" | 8 more` - `"fetch"` - `"scheduled"` - `"alarm"` - `"cron"` - `"queue"` - `"email"` - `"tail"` - `"rpc"` - `"websocket"` - `"workflow"` - `"unknown"` - `outcome: string` - `requestId: string` - `scriptName: string` - `wallTimeMs: number` - `diagnosticsChannelEvents?: Array` - `channel: string` - `message: string` - `timestamp: number` - `dispatchNamespace?: string` - `durableObjectId?: string` - `entrypoint?: string` - `event?: Record` - `executionModel?: "durableObject" | "stateless"` - `"durableObject"` - `"stateless"` - `scriptVersion?: ScriptVersion` - `id?: string` - `message?: string` - `tag?: string` - `truncated?: boolean` - `traces?: Array` - `rootSpanName: string` - `rootTransactionName: string` - `service: Array` - `spans: number` - `traceDurationMs: number` - `traceEndMs: number` - `traceId: string` - `traceStartMs: number` - `errors?: Array` ### Telemetry Values Response - `TelemetryValuesResponse` - `dataset: string` - `key: string` - `type: "string" | "boolean" | "number"` - `"string"` - `"boolean"` - `"number"` - `value: string | number | boolean` - `string` - `number` - `boolean` # Destinations ## Get Destinations `client.workers.observability.destinations.list(DestinationListParamsparams, RequestOptionsoptions?): SinglePage` **get** `/accounts/{account_id}/workers/observability/destinations` List your Workers Observability Telemetry Destinations. ### Parameters - `params: DestinationListParams` - `account_id: string` Path param: Your Cloudflare account ID. - `order?: "asc" | "desc"` Query param - `"asc"` - `"desc"` - `orderBy?: "created" | "updated"` Query param - `"created"` - `"updated"` - `page?: number` Query param - `perPage?: number` Query param ### Returns - `DestinationListResponse` - `configuration: Configuration` - `destination_conf: string` - `headers: Record` - `jobStatus: JobStatus` - `error_message: string` - `last_complete: string` - `last_error: string` - `logpushDataset: "opentelemetry-traces" | "opentelemetry-logs"` - `"opentelemetry-traces"` - `"opentelemetry-logs"` - `type: "logpush"` - `"logpush"` - `url: string` - `enabled: boolean` - `name: string` - `scripts: Array` - `slug: string` ### Example ```node import Cloudflare from 'cloudflare'; const client = new Cloudflare({ apiEmail: process.env['CLOUDFLARE_EMAIL'], // This is the default and can be omitted apiKey: process.env['CLOUDFLARE_API_KEY'], // This is the default and can be omitted }); // Automatically fetches more pages as needed. for await (const destinationListResponse of client.workers.observability.destinations.list({ account_id: 'account_id', })) { console.log(destinationListResponse.configuration); } ``` #### Response ```json { "errors": [ { "message": "message" } ], "messages": [ { "message": "Successful request" } ], "result": [ { "configuration": { "destination_conf": "destination_conf", "headers": { "foo": "string" }, "jobStatus": { "error_message": "error_message", "last_complete": "last_complete", "last_error": "last_error" }, "logpushDataset": "opentelemetry-traces", "type": "logpush", "url": "url" }, "enabled": true, "name": "name", "scripts": [ "string" ], "slug": "slug" } ], "success": true } ``` ## Create Destination `client.workers.observability.destinations.create(DestinationCreateParamsparams, RequestOptionsoptions?): DestinationCreateResponse` **post** `/accounts/{account_id}/workers/observability/destinations` Create a new Workers Observability Telemetry Destination. ### Parameters - `params: DestinationCreateParams` - `account_id: string` Path param: Your Cloudflare account ID. - `configuration: Configuration` Body param - `headers: Record` - `logpushDataset: "opentelemetry-traces" | "opentelemetry-logs"` - `"opentelemetry-traces"` - `"opentelemetry-logs"` - `type: "logpush"` - `"logpush"` - `url: string` - `enabled: boolean` Body param - `name: string` Body param - `skipPreflightCheck?: boolean` Body param ### Returns - `DestinationCreateResponse` - `configuration: Configuration` - `destination_conf: string` - `logpushDataset: "opentelemetry-traces" | "opentelemetry-logs"` - `"opentelemetry-traces"` - `"opentelemetry-logs"` - `logpushJob: number` - `type: "logpush"` - `"logpush"` - `url: string` - `enabled: boolean` - `name: string` - `scripts: Array` - `slug: string` ### Example ```node import Cloudflare from 'cloudflare'; const client = new Cloudflare({ apiEmail: process.env['CLOUDFLARE_EMAIL'], // This is the default and can be omitted apiKey: process.env['CLOUDFLARE_API_KEY'], // This is the default and can be omitted }); const destination = await client.workers.observability.destinations.create({ account_id: 'account_id', configuration: { headers: { foo: 'string' }, logpushDataset: 'opentelemetry-traces', type: 'logpush', url: 'url', }, enabled: true, name: 'name', }); console.log(destination.configuration); ``` #### Response ```json { "errors": [ { "message": "message" } ], "messages": [ { "message": "Resource created" } ], "result": { "configuration": { "destination_conf": "destination_conf", "logpushDataset": "opentelemetry-traces", "logpushJob": 0, "type": "logpush", "url": "url" }, "enabled": true, "name": "name", "scripts": [ "string" ], "slug": "slug" }, "success": true } ``` ## Update Destination `client.workers.observability.destinations.update(stringslug, DestinationUpdateParamsparams, RequestOptionsoptions?): DestinationUpdateResponse` **patch** `/accounts/{account_id}/workers/observability/destinations/{slug}` Update an existing Workers Observability Telemetry Destination. ### Parameters - `slug: string` - `params: DestinationUpdateParams` - `account_id: string` Path param: Your Cloudflare account ID. - `configuration: Configuration` Body param - `headers: Record` - `type: "logpush"` - `"logpush"` - `url: string` - `enabled: boolean` Body param ### Returns - `DestinationUpdateResponse` - `configuration: Configuration` - `destination_conf: string` - `logpushDataset: "opentelemetry-traces" | "opentelemetry-logs"` - `"opentelemetry-traces"` - `"opentelemetry-logs"` - `logpushJob: number` - `type: "logpush"` - `"logpush"` - `url: string` - `enabled: boolean` - `name: string` - `scripts: Array` - `slug: string` ### Example ```node import Cloudflare from 'cloudflare'; const client = new Cloudflare({ apiEmail: process.env['CLOUDFLARE_EMAIL'], // This is the default and can be omitted apiKey: process.env['CLOUDFLARE_API_KEY'], // This is the default and can be omitted }); const destination = await client.workers.observability.destinations.update('slug', { account_id: 'account_id', configuration: { headers: { foo: 'string' }, type: 'logpush', url: 'url', }, enabled: true, }); console.log(destination.configuration); ``` #### Response ```json { "errors": [ { "message": "message" } ], "messages": [ { "message": "Successful request" } ], "result": { "configuration": { "destination_conf": "destination_conf", "logpushDataset": "opentelemetry-traces", "logpushJob": 0, "type": "logpush", "url": "url" }, "enabled": true, "name": "name", "scripts": [ "string" ], "slug": "slug" }, "success": true } ``` ## Delete Destination `client.workers.observability.destinations.delete(stringslug, DestinationDeleteParamsparams, RequestOptionsoptions?): DestinationDeleteResponse` **delete** `/accounts/{account_id}/workers/observability/destinations/{slug}` Delete a Workers Observability Telemetry Destination. ### Parameters - `slug: string` - `params: DestinationDeleteParams` - `account_id: string` Your Cloudflare account ID. ### Returns - `DestinationDeleteResponse` - `configuration: Configuration` - `destination_conf: string` - `logpushDataset: "opentelemetry-traces" | "opentelemetry-logs"` - `"opentelemetry-traces"` - `"opentelemetry-logs"` - `logpushJob: number` - `type: "logpush"` - `"logpush"` - `url: string` - `enabled: boolean` - `name: string` - `scripts: Array` - `slug: string` ### Example ```node import Cloudflare from 'cloudflare'; const client = new Cloudflare({ apiEmail: process.env['CLOUDFLARE_EMAIL'], // This is the default and can be omitted apiKey: process.env['CLOUDFLARE_API_KEY'], // This is the default and can be omitted }); const destination = await client.workers.observability.destinations.delete('slug', { account_id: 'account_id', }); console.log(destination.configuration); ``` #### Response ```json { "errors": [ { "message": "message" } ], "messages": [ { "message": "Successful request" } ], "success": true, "result": { "configuration": { "destination_conf": "destination_conf", "logpushDataset": "opentelemetry-traces", "logpushJob": 0, "type": "logpush", "url": "url" }, "enabled": true, "name": "name", "scripts": [ "string" ], "slug": "slug" } } ``` ## Domain Types ### Destination List Response - `DestinationListResponse` - `configuration: Configuration` - `destination_conf: string` - `headers: Record` - `jobStatus: JobStatus` - `error_message: string` - `last_complete: string` - `last_error: string` - `logpushDataset: "opentelemetry-traces" | "opentelemetry-logs"` - `"opentelemetry-traces"` - `"opentelemetry-logs"` - `type: "logpush"` - `"logpush"` - `url: string` - `enabled: boolean` - `name: string` - `scripts: Array` - `slug: string` ### Destination Create Response - `DestinationCreateResponse` - `configuration: Configuration` - `destination_conf: string` - `logpushDataset: "opentelemetry-traces" | "opentelemetry-logs"` - `"opentelemetry-traces"` - `"opentelemetry-logs"` - `logpushJob: number` - `type: "logpush"` - `"logpush"` - `url: string` - `enabled: boolean` - `name: string` - `scripts: Array` - `slug: string` ### Destination Update Response - `DestinationUpdateResponse` - `configuration: Configuration` - `destination_conf: string` - `logpushDataset: "opentelemetry-traces" | "opentelemetry-logs"` - `"opentelemetry-traces"` - `"opentelemetry-logs"` - `logpushJob: number` - `type: "logpush"` - `"logpush"` - `url: string` - `enabled: boolean` - `name: string` - `scripts: Array` - `slug: string` ### Destination Delete Response - `DestinationDeleteResponse` - `configuration: Configuration` - `destination_conf: string` - `logpushDataset: "opentelemetry-traces" | "opentelemetry-logs"` - `"opentelemetry-traces"` - `"opentelemetry-logs"` - `logpushJob: number` - `type: "logpush"` - `"logpush"` - `url: string` - `enabled: boolean` - `name: string` - `scripts: Array` - `slug: string`